#include <iostream>

using namespace std;

int main()
{
    int n,q;cin>>n>>q;
    int a[n]={},p[n]={},b[q]={},suma[n]={},an[q]={};
    for(int i=0;i<n;i++){
        int x,y;
        cin>>x>>y;
        a[i]=x;
        p[i]=y;
        for(int j=i;j<n;j++){
            suma[j]+=a[i];
        }
    }
    for(int i=0;i<q;i++){
        int x;
        cin>>x;
        if(x>suma[n-1]){
            an[i]=-1;
        }
        else{
            for(int j=0;j<n;j++){
                if(suma[j]>=x){
                    an[i]=j+1;
                    break;
                }
            }
        }
    }
    for(int i=0;i<q;i++){
        cout<<an[i]<<endl;
    }

}